

// Fichier Depart_Bleue.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *			Recharge le barillet cot Bleue				*
 *                                                      *
 * .Date de cration : 23/04/08                         *
 * .Auteur : Jrmie LUMINEAU							*       
 *                                                      *
 * .Descriptions :                                      *
 *      - code du rechargement du barillet							*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <delays.h>
#include "mystdio.h"


#include "strategie_bleu.h"
#include "Recharge_barillet_bleu.h"
#include "lcd.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "IO.h"
#include "I2C_Master.h"
#include "barillet.h"
#include "Horloge.h"
#include "led.h"
#include "Telemetres.h"
#include "serial.h"
#include "canon.h"
#include "Tourelle.h"
#include "Recal.h"
#include "Distributeur.h"
#include "Constante.h"







// --------------------------------------------------------------------------
/* 
 * Rammasse les deux premires balles bleues sur la table
 * Prends 3 balles au distributeur blanc
 * Fait le complment de bleues si ncessaire
 * Va tout dposer dans le conteneur standard
*/
void Rechargement_Barillet_Bleu (unsigned char Nb_Voyages)
{
	
	
	
	
	unsigned char	etat=0;										// Etat courant de la machine principale
	unsigned char   Etat_Rouleaux=0;							// Etat courant de la machine  tat pour les rouleaux
	
	char 			ismoving=0;
	char			transition=0;
	char			adv_devant=0;
	char			adv_derriere=0;
	float 			Beta;
	int				X;
	int 			ret;
	int 			NbEvit=0;									// nombre d'vitements 
	char 			flag=0;
	int 			nbballes;
	
	
	while( etat!=255 ){
		if( transition )
			print_strint( ">RECH Bar=", etat, 1 );
			
		// mise  jour des nouvelles conditions de transition :
		ismoving = IsMove_Propulsion();
			
		adv_devant=Adversaire_Devant();					// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
		adv_derriere=Adversaire_Derriere();				// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
		
		if( transition && etat!=13 )					// Ne pas arrter les moteurs entre les changements d'angles
		{
			Stop_Propulsion();
			while (Etat_Propulsion()!='a');
		}

	
		
		
				
		nbballes = NbBalles_Barillet(TOUTES);
		if( nbballes==5 )								// si on a 5 balles,
			Commande_Rouleaux(-60, -60);				// inverser le sens des rouleaux
			
		if( nbballes==5 || (NbEvit>=3 && nbballes!=0) )	// quitter si 5 balles ou si trop d'vitements et au moins 1 balle
			etat = 255;
		
		Delay100TCYx(1);										// Attente entre deux cycles	
	
		switch (etat){
			
			case 0 :
				Beta=Angle_Robot_Adverse();
				X=X_Propulsion();
				//print_strint("beta=", Beta, 1 );
				//print_strint("x=", X, 1 );
				
				if (Beta<(175-0.032*X) || Nb_Balles_Distributeur_Blanc_Rouge==0 ){
					print_str( "->chez nous\n" );
					etat = 3;		// aller chez nous
				}
				else{
					print_str( "->chez adv\n" );
					etat = 1;		// aller chez l'adv
				}
				transition = 1;
				break;
					
			case 1 : 
				if (transition){
					GotoXY_Propulsion(500,750,100);
					transition = 0;
				}
				else if(adv_devant>=2){
					transition=1;
					etat=5;
				}
				else if( !ismoving ){
					if (Etat_Propulsion()=='g')
					{
						transition = 1;
						etat = 5;	
					}
					else
					{
						transition = 1;
						etat = 10;	
					}
				}
				break;
				
			case 2 :
				NbEvit++;
				Evite_Robot_Adverse(NbEvit);
				transition = 1;
				etat = 3;
				break;
				
			case 3 :
				if(transition){
					GotoXY_Propulsion(2600,400,100);
					transition = 0;
				}
				else if(Adversaire_Devant()>=2 ||
						Etat_Propulsion()=='g'){
					if( X_Propulsion()>2000){
						if( flag ){
							transition = 1;
							etat = 100;
						}else if( Nb_Balles_Distributeur_Blanc_Rouge!=0 ){
							transition = 1;
							etat = 150;
						}
						else {
							transition = 1;
							etat = 2;						
						}
					}
					else{
						transition = 1;
						etat = 2;
					}
				}
				else if(Etat_Propulsion()=='a')
				{
					transition = 1;
					etat = 4;	
				}				
				break;
				
			case 4 :

				print_strint("nb_voyages=",Nb_Voyages, 1);
				print_strint("compl:bleues=",2+Nb_Voyages%2, 1);
				ret = Complement_Bleu(2+Nb_Voyages%2,3-Nb_Voyages%2);
				//print_strint("compl=", ret, 1 );
				transition = 1;
				etat = 255;
				break;
			
			case 5 :
				Delay10KTCYx(DELAY500ms);
				transition=1;
				etat = 12;
				break;
				
			case 10 :
				if(transition){
					Angle_Propulsion(PI,30);
					transition = 0;
				}
				else if( !ismoving ){
					transition = 1;
					etat = 11;
				}
				break;
			
			case 11 :
				Distributeur_Blanc_Rouge(3-Nb_Voyages%2,1);
				flag = 1;
				transition = 1;
				etat = 12;
				break;
			
			case 12 :
				if(transition){
					GotoXY_Propulsion(2600,400,-80);
					transition = 0;
				}
				else if(Adversaire_Derriere()>=2){
					transition = 1;
					etat = 14;
				}
				else if( !ismoving ){
					if (Etat_Propulsion()=='g')
					{
						transition = 1;
						etat = 14;	
					}
					else
					{
						transition = 1;
						etat = 13;	
					}
				}
				break;					
			
			case 13 :
				if(transition){
					Angle_Propulsion(-PI/2, 40);
					transition = 0;
				}else if( !ismoving || A_Propulsion()<-3041 ){
					transition = 1;
					etat = 4;	
				}
				break;					
			
			case 14 :				
				NbEvit++;
				Evite_Robot_Adverse (NbEvit);
				transition=1;
				etat = 3;
				break;
			
			case 100 :
				if(transition){
					GotoXY_Propulsion(1800,400,-60);
					transition = 0;
				}
				else if( !ismoving ){
					transition = 1;
					etat = 101;
				}
				break;
			
			case 101 :
				if(transition){
					Angle_Propulsion(-PI/2.000,30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=102;
				}
				break;
			
			case 102 :
				Recal_Avant();
				transition=1;
				etat = 103;
				break;
			
			case 103 :
				if(transition){
					GotoXY_Propulsion(1800, 400,-30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=104;
				}
				break;
			
			case 104 :
				if(transition){
					Angle_Propulsion(PI,30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=105;
				}
				break;
			
			case 105 :
				if(transition){
					GotoXY_Propulsion(2200, 400,-40);
					transition=0;
				}
				else if( Etat_Propulsion()=='a' ){
					transition=1;
					etat=106;
				}
				break;
			
			case 106 :
				if(transition){
					Angle_Propulsion(-PI/2, 30);
					transition=0;
				}
				else if( !ismoving ){
					transition=1;
					etat=107;
				}
				break;
			
			case 107 :
				OrienteMax_Telemetre(10);
				transition=1;
				etat=108;
				break;
			
			case 108 :
				Distributeur_Bleu(5,1);
				transition = 1;
				etat = 255;
				break;
			
			
			case 150 :
				Delay10KTCYx(DELAY500ms);
				transition=1;
				etat = 151;
				break;
			
			case 151 :
				if (transition){
					GotoXY_Propulsion(500,750,-80);
					transition = 0;
				}
				else if(adv_derriere>=2 || Etat_Propulsion()=='g'){
					transition=1;
					etat=5;
				}
				else if(Etat_Propulsion()=='a')
				{
					transition = 1;
					etat = 152;	
				}
				break;
			
			case 152 :
				if(transition){
					Angle_Propulsion( PI, 30 );
					transition=0;
				}
				else if( !ismoving ){
					transition=1;
					etat=153;
				}
				break;
			
			case 153 :
				OrienteMax_Telemetre(10);
				transition=1;
				etat=11;
				break;
			
			
			default : // pas normal : quitter
				etat = 255;
	
		} // fin switch()
		
	} //fin while(etat!=255)
}	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
/*	char 			config=0;											// Position de l'adversaire	
	// ------------------------------------------------------------------
	// Phase 1 : Localisation de l'adversaire et choix de la stratgie
	//	
	
	if (NbBalles_Barillet(TOUTES)<5)									// Si on est pas plein, on active les rouleaux
		Commande_Rouleaux(90, 90);	
	
	config=1;															// Config 1 par dfaut, on retourne de notre ct
	if (Angle_Robot_Adverse()<97 && Distance_Robot_Adverse()!=0)		// Si on sait ou est l'adversaire et qu'il est de notre ct
		config=2;														// On va lui prendre ses balles
	
	
	
	if (config==1)
	{
		print_str ("Ph 4a: Chez nous\n");									// Config 1: on rentre au bercaille
		Goto_Cote_Rouge ();												// On va vers nos distributeurs
			
		if(	Distance_Robot_Adverse())
		{
			if ((Angle_Absolu_Robot_Adverse()<-3.0*PI/4.0) && 			// S'il est au distributeur blanc
				(Angle_Absolu_Robot_Adverse()>+3.0*PI/4.0))
				config=2;												// On va lui prendre des balles
		
		}					
	}
	

	
	
	if (config==2)
	{
	 	print_str ("Ph 4b: Distri ad\n");										// Config 2: on va lui prendre des balles

		GotoXY_Propulsion(2500,750,100);									// On y va en avant
		while (	Etat_Propulsion ()!='a' &&
				Etat_Propulsion ()!='g');
		
		// On prend des balles blanches  l'adversaire
		
		
		if (Etat_Propulsion ()=='a')
		{
			Angle_Propulsion (0,25);										// S'oriente perpendiculaire  la largeur de la table ...
			while (Etat_Propulsion ()!='a' 									// ... pour tre face au distributeur
			&& NbBalles_Barillet(BLANCHE)<2);									
	
			GotoXY_Propulsion(3000,750,25);									// On avance vers le distributeur
			while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) &&					// Soit on a les switchs ...
					Etat_Propulsion()!='g' &&								// ... soit on est bloqu ...
					Etat_Propulsion()!='a');								// ... soit on est arriv !!!
																						
		
			Distributeur_Blanc_Bleu (Nb_Voyages+1,1);					// ... on choppe deux balles au distributeur
				
			if (NbBalles_Barillet(TOUTES)<5)								// Si on est pas plein, on active les rouleaux
				Commande_Rouleaux(90, 90);	
		}
		else
		{
			Stop_Propulsion();									// On stoppe les moteurs
			ToutDroit_Propulsion(150,-50);						// On recule de 15cm
		
			while (	Etat_Propulsion ()!='a' &&					// Jusqu'au blocage ou l'arrt
					Etat_Propulsion ()!='g');
		}
		
		Goto_Cote_Rouge_Arriere ();											// On retourne du ct bleu											
	}
	
	
		
						
	if (!(Distance_Robot_Adverse()!=0 &&									// Que l'on voit le robot adverse
		Angle_Absolu_Robot_Adverse()>-PI &&									// Et qu'il n'est pas dans le coin
	 	Angle_Absolu_Robot_Adverse()<-PI/2.0))						
	{
		
		Angle_Propulsion (-3*(PI/4),50);									// S'oriente en direction du coin
		while (Etat_Propulsion ()!='a');									// ... pour tre face au distributeur
			
		GotoXY_Propulsion (350,350,60);										// Avance au point de recalage
		while (	Etat_Propulsion ()!='a' &&
				Etat_Propulsion ()!='g');	
														
		if ( NbBalles_Barillet(BLANCHE)>=2)											
			Recal_Cote_Rouge (1,0);											// Recale le robot en X et en Psi
		else
			Recal_Cote_Rouge (1,1);											// Recale le robot en X, Y et en Psi
	}

						
								
	if (NbBalles_Barillet(BLANCHE)<2)											// Si on a pas les deux balles blanches
	{
		if(	!Distance_Robot_Adverse() || 										// Si on ne voit pas l'adversaire ...
		!(	Angle_Absolu_Robot_Adverse()<-3.0*PI/4.0 ||							// .. ou s'il n'est pas au distributeur blanc
			Angle_Absolu_Robot_Adverse()>+3.0*PI/4.0 ))
		{
			Angle_Propulsion (-PI,45);											// S'oriente perpendiculaire  la largeur de la table ...
			while (Etat_Propulsion ()!='a'); 									// ... pour tre face au distributeur
		
			Angle_Propulsion (-PI,25);											// S'oriente perpendiculaire  la largeur de la table ...
			while (Etat_Propulsion ()!='a'); 									// ... pour tre face au distributeur
		
			GotoXY_Propulsion(0, 750, 50 );										// Avance en face du distributeur
			while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 
				&& Etat_Propulsion()!='g' &&
				X_Propulsion()>400);	
													
			GotoXY_Propulsion(0, 750, 25 );										// Avance en face du distributeur
			while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 
				&& Etat_Propulsion()!='g');	
				
			if (Nb_Voyages==1)
				Distributeur_Blanc_Rouge(2,0);											// Prends 2 balles dans le distributeur blanc du ct bleu
			else
				Distributeur_Blanc_Bleu(Nb_Balles_Distributeur_Blanc_Rouge,0);					// Prends ce qu'il reste dans le distributeur blanc du ct bleu
			
			GotoXY_Propulsion(700, 750, -50);											// On recule dans l'alignement du distributeur
				while (Etat_Propulsion ()!='a' &&
				Etat_Propulsion ()!='g');
		}
	}
					
					
					
	while (NbBalles_Barillet(BLANCHE)>2 && Nb_Voyages==1)							// Si on a ramasser plus de deux balles blanche et qu'on est au deuxime voyage
	{
		if (!DeposeBalle_Barillet(BLANCHE));										// On ejecte le trop plein
		{
			while(!Barillet_Busy());												// On attends la fin de l'jection
			while(Barillet_Busy());
		}
	}
					
					
	if (NbBalles_Barillet(ROUGE)<3 && NbBalles_Barillet(TOUTES)<5) 					// Si on a pas les trois balles bleues et qu'il reste de la place
	{

		
		Angle_Propulsion (-PI/2.0,35);												// S'oriente en face du distributeur
		while (Etat_Propulsion ()!='a');
	
		GotoXY_Propulsion(700, 0, 50);												// Avancer vers le distributeur en avant
		while (	Etat_Propulsion ()!='g' &&											// On arrte si on est bloqu ...
				Etat_Propulsion ()!='a' && 											// ... ou si on est arriv (l il y a un problme !)...
				Y_Propulsion ()>440 &&												// ... ou on est proche du distributeur
				NbBalles_Barillet(ROUGE)<3);										// ... ou si on a les 3 balles blanches
				
		Stop_Propulsion();															// On arrte les moteurs
		if (Nb_Voyages==1)
			Distributeur_Rouge(3,1);													// Prends trois balles dans le distributeur
		else
			Distributeur_Rouge(Nb_Balles_Distributeur_Rouge,1);						// Prends trois balles dans le distributeur
		if (NbBalles_Barillet(TOUTES)==5)											// Si on a les 5 balles ..
			Commande_Rouleaux(-90, -90);											// On fait tourner les rouleaux pour ne pas en prendre une sixieme
	}*/









void Rechargement_Barillet_Bleu_Fin (char couleur)
{
	
	
	
	
	unsigned char	etat=0;										// Etat courant de la machine principale
	unsigned char   Etat_Rouleaux=0;							// Etat courant de la machine  tat pour les rouleaux
	
	char 			ismoving=0;
	char			transition=0;
	char			adv_devant=0;
	char			adv_derriere=0;
	float 			Beta;
	int				X;
	int 			ret;
	int 			NbEvit=0;									// nombre d'vitements 
	char 			flag=0;
	int 			nbballes;
	
	
	while( etat!=255 ){
		if( transition )
			print_strint( ">RECH Fin=", etat, 1 );
			
		// mise  jour des nouvelles conditions de transition :
		ismoving = IsMove_Propulsion();
			
		adv_devant=Adversaire_Devant();					// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
		adv_derriere=Adversaire_Derriere();				// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
		
		if( transition && etat!=13 )					// Ne pas arrter les moteurs entre les changements d'angles
		{
			Stop_Propulsion();
			while (Etat_Propulsion()!='a');
		}

	
		
		
				
		nbballes = NbBalles_Barillet(TOUTES);
		if( nbballes==5 )								// si on a 5 balles,
			Commande_Rouleaux(-60, -60);				// inverser le sens des rouleaux
			
		if( nbballes==5 || (NbEvit>=3 && nbballes!=0) )	// quitter si 5 balles ou si trop d'vitements et au moins 1 balle
			etat = 255;
		
		Delay100TCYx(1);										// Attente entre deux cycles	
	
		switch (etat){
			
			case 0 :
				etat=3;
				transition=1;
				break;
					
			case 2 :
				NbEvit++;
				Evite_Robot_Adverse(NbEvit);
				transition = 1;
				etat = 3;
				break;
				
			case 3 :
				if(transition){
					GotoXY_Propulsion(2600,400,100);
					transition = 0;
				}
				else if(Adversaire_Devant()>=2 || Etat_Propulsion()=='g'){
					if( X_Propulsion()>2000){
						if( couleur!=BLANCHE){
							transition = 1;
							etat = 100;
						}
						else {
							transition = 1;
							etat = 2;						
						}
					}
					else{
						transition = 1;
						etat = 2;
					}
				}
				else if(Etat_Propulsion()=='a')
				{
					transition = 1;
					etat = 4;	
				}				
				break;
				
			case 4 :
				if(couleur==BLANCHE)
					Complement_Bleu(0,5);
				else
					Complement_Bleu(5,0);
				transition = 1;
				etat = 255;
				break;
			
			case 100 :
				if(transition){
					GotoXY_Propulsion(1800,400,-80);
					transition = 0;
				}
				else if( !ismoving ){
					transition = 1;
					etat = 101;
				}
				break;
			
			case 101 :
				if(transition){
					Angle_Propulsion(-PI/2.000,30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=102;
				}
				break;
			
			case 102 :
				Recal_Avant();
				transition=1;
				etat = 103;
				break;
			
			case 103 :
				if(transition){
					GotoXY_Propulsion(1800, 400,-30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=104;
				}
				break;
			
			case 104 :
				if(transition){
					Angle_Propulsion(PI,30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=105;
				}
				break;
			
			case 105 :
				if(transition){
					GotoXY_Propulsion(2200, 400,-40);
					transition=0;
				}
				else if( Etat_Propulsion()=='a' ){
					transition=1;
					etat=106;
				}
				break;
			
			case 106 :
				if(transition){
					Angle_Propulsion(-PI/2, 30);
					transition=0;
				}
				else if( !ismoving ){
					transition=1;
					etat=107;
				}
				break;
			
			case 107 :
				OrienteMax_Telemetre(10);
				transition=1;
				etat=108;
				break;
			
			case 108 :
				Distributeur_Bleu(5,1);
				transition = 1;
				etat = 255;
				break;
			
			
			default : // pas normal : quitter
				etat = 255;
	
		} // fin switch()
		
	} //fin while(etat!=255)
	print_str( "fin rechfin\n" );
}