// Fichier Led.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 27/01/08                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/


#include "mystdio.h"
#include <delays.h>


#include "LCD.h"
#include "Joystick.h"
#include "CAN.h"
#include "Batteries.h"
#include "IO.h"
#include "Telemetres.h"
#include "Propulsion.h"
#include "I2C_Master.h"
#include "led.h"
#include "StartUp.h"
#include "Rouleaux.h"
#include "Serial.h"
#include "HighLevel.h"
#include "Barillet.h"
#include "Tourelle.h"
#include "Canon.h"



// --------------------------------------------------------------------------
/* Fonction Start_Up
 * Initialise tous les priphriques du robot
 *  - la led rouge
 *  - L'cran LCD
 *  - Les convertisseurs Analogiques/Numriques
 *  - Les entres sorties (Switch G/D & Jack)
 *  - La liaison srie
 *  - Le module I2C 
*/

void Init_Peripheriques (void)
{
	//ConfigureProcesseur();

	Led_Init();		// Initalisation de la led et des switchs
	LCD_Init();		// Afficheur LCD
	CAN_Init();		// Convertisseurs Analogiques/Numriques
	IO_Init();		// Initialisation des ports pour les switchs et le jack
	Serial_Init();	// Initialisation de la liaison srie
	I2C_Init();		// Initialisation du bus I2C	
}	

